module TicketAbstractorClient
  module Base
    module Errors
      class BaseError < StandardError; end
      class NotImplementedError < BaseError; end
      class ConfigurationError < BaseError; end
      class UnexpectedError < BaseError; end

      class AttachmentArgumentError < BaseError; end
      class CommentArgumentError < BaseError; end
      class ClientArgumentError < BaseError; end
      class TicketArgumentError < BaseError; end

      class AttachmentError < BaseError; end
      class CommentError < BaseError; end
      class TicketError < BaseError; end

      class ConnectionError < BaseError; end
      class NotFoundError < BaseError; end
      class ParseError < BaseError; end
      class RequsetFormatError < BaseError; end
      class AccessError < BaseError; end
    end
  end
end
