module TicketAbstractorClient
  module ClientHelper
    paths_to_load = %W(
      base/response_handler.rb
      base/*.rb
      jira/params_builder.rb
      jira/*.rb
      service_now/params_builder.rb
      service_now/*.rb
    )
    paths_to_load.each do |path|
      location = File.expand_path(path, __dir__)
      Dir[location].each { |f| require f }
    end

    Time::DATE_FORMATS[:jira_iso8601] = '%FT%T.%L%z'
    Time::DATE_FORMATS[:service_now] = '%m-%d-%y %l:%M %p'
    Time::DATE_FORMATS[:service_now_display_value] = '%m-%d-%y %-l:%M %p'
    Time::DATE_FORMATS[:service_now_iso8601] = '%F %T'
    Time::DATE_FORMATS[:unix_timestamp] = '%s'
    Time::DATE_FORMATS[:unix_timestamp_with_ms] = '%s.%5N'

    def get_jira_fields_meta(*jira_endpoint)
      jira_endpoints = Jira::Client.new.endpoints
      jira_endpoints = jira_endpoints.slice(*jira_endpoint) if jira_endpoint.present?

      jira_endpoints.each_with_object({}) do |(endpoint, _), result|
        result[endpoint.to_sym] = Jira::FieldsMeta.new(endpoint)
      end
    end
    module_function :get_jira_fields_meta
  end
end
