module TicketAbstractorClient
  class CommunicationData
    attr_accessor :method, :path, :args, :response, :executed_at,
      :total_response_time, :ta_response_time, :ts_response_time

    BINARY_RESPONSE_TEXT = 'Binary content'.freeze

    def initialize
      @binary_response = false
    end

    def binary_response!
      @binary_response = true
    end

    def binary_response?
      @binary_response
    end

    def response
      return BINARY_RESPONSE_TEXT if self.binary_response?

      @response
    end

    def to_h
      {
        method: self.method,
        path: self.path,
        args: self.args,
        response: self.response,
        executed_at: self.executed_at,
        total_response_time: self.total_response_time,
        ta_response_time: self.ta_response_time,
        ts_response_time: self.ts_response_time
      }
    end

    def to_json
      self.to_h.to_json
    end
  end
end
