module TicketAbstractorClient
  module ServiceNow
    class Comment < Base::Comment
      attr_accessor :ticket_id, :endpoint, :project

      def self.fetch(ticket_id, endpoint, project)
        client = Client.new(endpoint)
        response = client.get_comments(ticket_id: ticket_id, project: project)

        comments =
          response.map do |raw_comment|
            new({
              author: raw_comment['sys_created_by'],
              body: raw_comment['value'],
              external_created_at: raw_comment['sys_created_on'],
              ticket_id: ticket_id,
              endpoint: endpoint,
              project: project,
              communications_stack: client.communications_stack
            })
          end

        [comments, client.communications_stack]
      end

      def initialize(opts)
        super(opts)
        @ticket_id, @endpoint, @project = opts.values_at(:ticket_id, :endpoint, :project)
      end

      def sync!
        client = Client.new(@endpoint)
        response = client.create_comment(self)
        @communications_stack = client.communications_stack

        response
      end
    end
  end
end
